Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationParameterCollection.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationParameterCollection.cs	(revision 15017)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Configuration/PushConfigurationParameterCollection.cs	(revision 15017)
@@ -0,0 +1,335 @@
+﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Configuration {
+  using System.Collections.Generic;
+
+  using HeuristicLab.Common;
+  using HeuristicLab.Core;
+  using HeuristicLab.Data;
+  using HeuristicLab.Parameters;
+  using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Base.Erc;
+
+  [StorableClass]
+  public class PushConfigurationParameterCollection : PushConfigurationBase, IReadOnlyPushConfiguration {
+    private const string InstructionsParameterName = "Instructions";
+    private const string InstructionsParameterDescription = "Enables/Disables Instructions";
+    private const string EvalPushLimitParameterName = "EvalPushLimit";
+    private const string EvalPushLimitParameterDescription = "This is the maximum allowed number of \"executions\" in a single top-level call to the interpreter. The execution of a single Push instruction counts as one execution, as does the processing of a single literal, as does the descent into one layer of parentheses (that is, the processing of the \"(\" counts as one execution).";
+    private const string MaxPointsInProgramParameterName = "MaxProgramLength";
+    private const string MaxProgramLengthParameterDescription = "This is the maximum size of an item on the CODE/EXEC stack, expressed as a number of points. A point is an instruction, a literal, or a pair of parentheses.";
+    private const string TopLevelPushCodeParameterName = "TopLevelPushCode";
+    private const string TopLevelPushCodeParameterDescription = "When TRUE (which is the default), code passed to the top level of the interpreter will be pushed onto the CODE stack prior to execution.";
+    private const string TopLevelPopCodeParameterName = "TopLevelPopCode";
+    private const string TopLevelPopCodeParameterDescription = "When TRUE, the CODE stack will be popped at the end of top level calls to the interpreter. The default is FALSE.";
+    private const string MaxPointsInRandomInstructionParameterName = "MaxPointsInRandomInstruction";
+    private const string MaxPointsInRandomInstructionParameterDescription = "MaxPointsInRandomInstruction";
+    private const string ErcOptionsParameterName = "ERC options";
+    private const string MaxStringLengthParameterName = "Max. string length";
+    private const string MaxDepthParameterName = "Max. program recursion";
+    private const string MaxParenthesesCloseParameterName = "Max. parentheses close";
+    private const string MaxParenthesesCloseParameterDescription = "Specifies how many sub programs are closed if open during the recursive translation of an individual to a push program. Value is exclusive.";
+    private const string ParenthesesCloseBiasLevelParameterName = "Parentheses close bias level";
+    private const string ParenthesesCloseBiasLevelParameterDescription = "Specifies how strong a random value between 0 .. 'Max. parentheses close' is biased towards 0. In other words, this parameter controls the length of sub programs.";
+    private const string MaxVectorLengthParameterName = "Max. vector length";
+
+    public PushConfigurationParameterCollection() {
+      Parameters = new ParameterCollection();
+
+      InitParameters();
+    }
+
+    public PushConfigurationParameterCollection(PushConfigurationParameterCollection origin, Cloner cloner) : base(origin, cloner) {
+      Parameters = cloner.Clone(origin.Parameters);
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PushConfigurationParameterCollection(this, cloner);
+    }
+
+    [StorableConstructor]
+    protected PushConfigurationParameterCollection(bool deserialize) { }
+
+    [StorableHook(HookType.AfterDeserialization)]
+    // ReSharper disable once UnusedMember.Local
+    private void AfterDeserialization() {
+      InitParameters();
+    }
+
+    [Storable]
+    public ParameterCollection Parameters { get; private set; }
+
+    [Storable]
+    public string FloatStringFormat { get; set; }
+
+    private void InitParameters() {
+      if (!Parameters.ContainsKey(InstructionsParameterName))
+        Parameters.Add(new ValueParameter<IEnabledExpressionsConfiguration>(
+          InstructionsParameterName,
+          InstructionsParameterDescription,
+          this));
+
+      if (!Parameters.ContainsKey(ErcOptionsParameterName))
+        Parameters.Add(new ValueParameter<ErcOptions>(ErcOptionsParameterName));
+
+      if (!Parameters.ContainsKey(MaxVectorLengthParameterName))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MaxVectorLengthParameterName,
+          new IntValue(500)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(EvalPushLimitParameterName))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          EvalPushLimitParameterName,
+          EvalPushLimitParameterDescription,
+          new IntValue(1000)));
+
+      if (!Parameters.ContainsKey(MaxPointsInProgramParameterName))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MaxPointsInProgramParameterName,
+          MaxProgramLengthParameterDescription,
+          new IntValue(200)));
+
+      if (!Parameters.ContainsKey(MaxParenthesesCloseParameterName))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MaxParenthesesCloseParameterName,
+          MaxParenthesesCloseParameterDescription,
+          new IntValue(4)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(ParenthesesCloseBiasLevelParameterName))
+        Parameters.Add(new FixedValueParameter<DoubleValue>(
+          ParenthesesCloseBiasLevelParameterName,
+          ParenthesesCloseBiasLevelParameterDescription,
+          new DoubleValue(4)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(TopLevelPushCodeParameterName))
+        Parameters.Add(new FixedValueParameter<BoolValue>(
+          TopLevelPushCodeParameterName,
+          TopLevelPushCodeParameterDescription,
+          new BoolValue(true)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(TopLevelPopCodeParameterName))
+        Parameters.Add(new FixedValueParameter<BoolValue>(
+          TopLevelPopCodeParameterName,
+          TopLevelPopCodeParameterDescription,
+          new BoolValue(false)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(MaxPointsInRandomInstructionParameterName))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MaxPointsInRandomInstructionParameterName,
+          MaxPointsInRandomInstructionParameterDescription,
+          new IntValue(50)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(MaxStringLengthParameterName))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MaxStringLengthParameterName,
+          new IntValue(1000)) { Hidden = true });
+
+      if (!Parameters.ContainsKey(MaxDepthParameterName))
+        Parameters.Add(new FixedValueParameter<IntValue>(
+          MaxDepthParameterName,
+          new IntValue(1000)) { Hidden = true });
+    }
+
+    public IValueParameter<IEnabledExpressionsConfiguration> InstructionsParameter
+    {
+      get { return (IValueParameter<IEnabledExpressionsConfiguration>)Parameters[InstructionsParameterName]; }
+    }
+
+    public IEnabledExpressionsConfiguration Instructions
+    {
+      get { return InstructionsParameter.Value; }
+      set { InstructionsParameter.Value = value; }
+    }
+
+    public IValueParameter<ErcOptions> ErcOptionsParameter
+    {
+      get { return (IValueParameter<ErcOptions>)Parameters[ErcOptionsParameterName]; }
+    }
+
+    public ErcOptions ErcOptions
+    {
+      get { return ErcOptionsParameter.Value; }
+      set
+      {
+        ErcOptionsParameter.Value = value;
+      }
+    }
+
+    IReadOnlyList<string> IReadOnlyPushConfiguration.EnabledExpressions
+    {
+      get
+      {
+        return enabledExpressions;
+      }
+    }
+
+    IReadOnlyErcOptions IReadOnlyPushConfiguration.ErcOptions
+    {
+      get
+      {
+        return ErcOptions;
+      }
+    }
+
+    /// <summary>
+    ///     This is the maximum allowed number of "executions" in a single top-level call to the interpreter.
+    ///     The execution of a single Push instruction counts as one execution, as does the processing of a single literal,
+    ///     as does the descent into one layer of parentheses (that is, the processing of the "(" counts as one execution).
+    ///     When this limit is exceeded the interpreter aborts immediately, leaving its stacks in the states they were in prior
+    ///     to the abort (so they may still be examined by a calling program). Whether or not this counts as an "abnormal"
+    ///     termination
+    ///     is up to the calling program.
+    /// </summary>
+    public IValueParameter<IntValue> EvalPushLimitParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[EvalPushLimitParameterName]; }
+    }
+
+    public int EvalPushLimit
+    {
+      get { return EvalPushLimitParameter.Value.Value; }
+      set { EvalPushLimitParameter.Value.Value = value; }
+    }
+
+
+    /// <summary>
+    /// This is the maximum of depth a push program can have. Expressions, which lead to exceed this limit are interpreted as NOOP.
+    /// </summary>
+    public IValueParameter<DoubleValue> ParenthesesCloseBiasLevelParameter
+    {
+      get { return (IValueParameter<DoubleValue>)Parameters[ParenthesesCloseBiasLevelParameterName]; }
+    }
+
+    public double ParenthesesCloseBiasLevel
+    {
+      get { return ParenthesesCloseBiasLevelParameter.Value.Value; }
+      set { ParenthesesCloseBiasLevelParameter.Value.Value = value; }
+    }
+
+    /// <summary>
+    /// This is the maximum of depth a push program can have. Expressions, which lead to exceed this limit are interpreted as NOOP.
+    /// </summary>
+    public IValueParameter<IntValue> MaxParenthesesCloseParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MaxParenthesesCloseParameterName]; }
+    }
+
+    public int MaxParenthesesClose
+    {
+      get { return MaxParenthesesCloseParameter.Value.Value; }
+      set
+      {
+        MaxParenthesesCloseParameter.Value.Value = value;
+      }
+    }
+
+    /// <summary>
+    /// This is the maximum of depth a push program can have. Expressions, which lead to exceed this limit are interpreted as NOOP.
+    /// </summary>
+    public IValueParameter<IntValue> MaxDepthParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MaxDepthParameterName]; }
+    }
+
+    public int MaxDepth
+    {
+      get { return MaxDepthParameter.Value.Value; }
+      set
+      {
+        MaxDepthParameter.Value.Value = value;
+      }
+    }
+
+    /// <summary>
+    ///     This is the maximum size of an item on the CODE stack, expressed as a number of points.
+    ///     A point is an instruction, a literal, or a pair of parentheses. Any instruction that would cause this limit to be
+    ///     exceeded should instead act as a NOOP, leaving all stacks in the states that they were in before the execution of the
+    ///     instruction.
+    /// </summary>
+    public IValueParameter<IntValue> MaxPointsInProgramParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MaxPointsInProgramParameterName]; }
+    }
+
+    public int MaxPointsInProgram
+    {
+      get { return MaxPointsInProgramParameter.Value.Value; }
+      set
+      {
+        MaxPointsInProgramParameter.Value.Value = value;
+      }
+    }
+
+    public IValueParameter<IntValue> MaxVectorLengthParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MaxVectorLengthParameterName]; }
+    }
+
+    public int MaxVectorLength
+    {
+      get { return MaxVectorLengthParameter.Value.Value; }
+      set { MaxVectorLengthParameter.Value.Value = value; }
+    }
+
+    /// <summary>
+    ///     The maximum number of points in an expression produced by the CODE.RAND instruction.
+    /// </summary>
+    public IValueParameter<IntValue> MaxPointsInRandomExpressionParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MaxPointsInRandomInstructionParameterName]; }
+    }
+
+    public int MaxPointsInRandomExpression
+    {
+      get { return MaxPointsInRandomExpressionParameter.Value.Value; }
+      set
+      {
+        MaxPointsInRandomExpressionParameter.Value.Value = value;
+      }
+    }
+
+    /// <summary>
+    ///     When TRUE (which is the default), code passed to the top level of the interpreter
+    ///     will be pushed onto the CODE stack prior to execution.
+    /// </summary>
+    public IValueParameter<BoolValue> TopLevelPushCodeParameter
+    {
+      get { return (IValueParameter<BoolValue>)Parameters[TopLevelPushCodeParameterName]; }
+    }
+
+    public bool TopLevelPushCode
+    {
+      get { return TopLevelPushCodeParameter.Value.Value; }
+      set
+      {
+        TopLevelPushCodeParameter.Value.Value = value;
+      }
+    }
+
+    /// <summary>
+    ///     When TRUE, the CODE stack will be popped at the end of top level calls to the interpreter. The default is FALSE.
+    /// </summary>
+    public IValueParameter<BoolValue> TopLevelPopCodeParameter
+    {
+      get { return (IValueParameter<BoolValue>)Parameters[TopLevelPopCodeParameterName]; }
+    }
+
+    public bool TopLevelPopCode
+    {
+      get { return TopLevelPopCodeParameter.Value.Value; }
+      set
+      {
+        TopLevelPopCodeParameter.Value.Value = value;
+      }
+    }
+
+    public IValueParameter<IntValue> MaxStringLengthParameter
+    {
+      get { return (IValueParameter<IntValue>)Parameters[MaxStringLengthParameterName]; }
+    }
+
+    public int MaxStringLength
+    {
+      get { return MaxStringLengthParameter.Value.Value; }
+      set { MaxStringLengthParameter.Value.Value = value; }
+    }
+  }
+}
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Constants/Environment.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Constants/Environment.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Constants/Environment.cs	(revision 15017)
@@ -2,9 +2,19 @@
   public static class PushEnvironment {
     public const char VectorStartSymbol = '[';
+    public const string VectorStartSymbolStr = "[";
     public const char VectorEndSymbol = ']';
+    public const string VectorEndSymbolStr = "]";
     public const char VectorSeparatorSymbol = ' ';
+    public const string VectorSeparatorSymbolStr = " ";
 
-    public const char CharacterSymbol = '\'';
+    public const char ProgramStartSymbol = '(';
+    public const string ProgramStartSymbolStr = "(";
+    public const char ProgramEndSymbol = ')';
+    public const string ProgramEndSymbolStr = ")";
+
+    public const char CharSymbol = '\'';
     public const char StringSymbol = '\"';
+    public const string CharSymbolStr = "'";
+    public const string StringSymbolStr = "\"";
     public const string NewLine = "\n";
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ManagedPoolProvider.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ManagedPoolProvider.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Pool/ManagedPoolProvider.cs	(revision 15017)
@@ -25,10 +25,10 @@
 
     public readonly int PartitionSize;
-    public readonly int MaxParitionCount;
+    public readonly int MaxPartitionCount;
     public const int DefaultMaxInstanceCount = 65536;
 
     public ManagedPoolProvider(int partitionSize, Func<T> factory, int? maxPartitionCount = null) {
       PartitionSize = partitionSize;
-      MaxParitionCount = maxPartitionCount ?? DefaultMaxInstanceCount / PartitionSize;
+      MaxPartitionCount = maxPartitionCount ?? DefaultMaxInstanceCount / PartitionSize;
       this.factory = factory;
 
@@ -50,6 +50,10 @@
     }
 
+    public void Clear() {
+      partitions.Clear();
+    }
+
     public void ReleasePartitions(List<T[]> releasedPartitions) {
-      if (partitions.Count < MaxParitionCount)
+      if (partitions.Count < MaxPartitionCount)
         partitions.PushRange((T[][])InternalListArrayProperty.GetValue(releasedPartitions), 0, releasedPartitions.Count);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeExtensions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeExtensions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeExtensions.cs	(revision 15017)
@@ -8,9 +8,12 @@
 
   public static class TreeExtensions {
-    public static Tree<T> ToTree<T>(
+    private static readonly Expression ExecNoop = ExpressionTable.GetStatelessExpression<ExecNoopExpression>();
+    private static readonly Expression CodeNoop = ExpressionTable.GetStatelessExpression<CodeNoopExpression>();
+
+    public static TreeNode<T> ToTree<T>(
       this IEnumerable<T> items,
       Predicate<T> isChild,
       Func<T, IReadOnlyList<T>> childrenResolver) {
-      var tree = new Tree<T>();
+      var tree = new TreeNode<T>();
 
       foreach (var item in items) {
@@ -35,4 +38,6 @@
         } else yield return child;
       }
+
+      yield return node;
     }
 
@@ -46,5 +51,16 @@
     }
 
+    public static PushProgram ToPushProgramWithoutNoopExpressions(this TreeNode<Expression> tree) {
+      return ToPushProgram(tree, e => !ReferenceEquals(e, ExecNoop) && !ReferenceEquals(e, CodeNoop));
+    }
+
     public static PushProgram ToPushProgram(this TreeNode<Expression> tree, Func<Expression, bool> condition = null) {
+      // wrap into program as depthlast expects that tree represents program and not a single expression
+      if (tree.Count == 1) {
+        var tmp = tree;
+        tree = new TreeNode<Expression>();
+        tree.AddNode(tmp);
+      }
+
       var expressions = tree.DepthLast(e => ResolveProgram(e, condition));
 
@@ -52,5 +68,5 @@
     }
 
-    public static Tree<Expression> ToTree(this PushProgram program) {
+    public static TreeNode<Expression> ToTree(this PushProgram program) {
       var tree = program.Expressions.ToTree(e => e.IsProgram, e => ((PushProgram)e).Expressions);
       tree.Value = program;
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeNode.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeNode.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Data/Tree/TreeNode.cs	(revision 15017)
@@ -5,7 +5,9 @@
     public T Value { get; set; }
     public IList<TreeNode<T>> Children { get; private set; }
+    public int Count { get; private set; }
 
     public TreeNode() {
       Children = new List<TreeNode<T>>();
+      Count = 1;
     }
 
@@ -16,12 +18,16 @@
     public void Add(T value) {
       Children.Add(new TreeNode<T>(value));
+      Count++;
     }
 
     public void AddNode(TreeNode<T> node) {
       Children.Add(node);
+      Count += node.Count;
     }
 
     public void ReplaceNode(int index, TreeNode<T> node) {
+      Count -= Children[index].Count;
       Children[index] = node;
+      Count += node.Count;
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/BooleanExpressions.cs	(revision 15017)
@@ -29,5 +29,5 @@
       var result = second && first;
 
-      interpreter.BooleanStack.SetTop(result);
+      interpreter.BooleanStack.Top = result;
     }
   }
@@ -52,5 +52,5 @@
       var result = second || first;
 
-      interpreter.BooleanStack.SetTop(result);
+      interpreter.BooleanStack.Top = result;
     }
   }
@@ -71,5 +71,5 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      interpreter.BooleanStack.SetTop(!interpreter.BooleanStack.Top);
+      interpreter.BooleanStack.Top = !interpreter.BooleanStack.Top;
     }
   }
@@ -134,5 +134,5 @@
       var result = second && !first;
 
-      interpreter.BooleanStack.SetTop(result);
+      interpreter.BooleanStack.Top = result;
     }
   }
@@ -157,5 +157,5 @@
       var result = !second && first;
 
-      interpreter.BooleanStack.SetTop(result);
+      interpreter.BooleanStack.Top = result;
     }
   }
@@ -181,5 +181,5 @@
       var result = second ^ first;
 
-      interpreter.BooleanStack.SetTop(result);
+      interpreter.BooleanStack.Top = result;
     }
   }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CharExpressions.cs	(revision 15017)
@@ -1,4 +1,6 @@
 ﻿namespace HeuristicLab.Problems.ProgramSynthesis.Push.Expressions {
   using System;
+  using System.Linq;
+
   using Attributes;
   using Interpreter;
@@ -107,5 +109,5 @@
 
     public override void Eval(IInternalPushInterpreter interpreter) {
-      var chars = interpreter.StringStack.Pop().ToCharArray();
+      var chars = interpreter.StringStack.Pop().Reverse().ToArray();
       interpreter.CharStack.Push(chars);
     }
Index: /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs
===================================================================
--- /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 15016)
+++ /branches/PushGP/HeuristicLab.PushGP/HeuristicLab.Problems.ProgramSynthesis/Push/Expressions/CodeExpressions.cs	(revision 15017)
@@ -12,4 +12,5 @@
 
   using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+  using HeuristicLab.Problems.ProgramSynthesis.Push.Extensions;
 
   using Interpreter;
@@ -185,5 +186,5 @@
       }
 
-      interpreter.CodeStack.SetTop(result);
+      interpreter.CodeStack.Top = result;
     }
   }
@@ -235,5 +236,5 @@
       var first = expand.Expressions[expand.Expressions.Count - 1];
 
-      interpreter.CodeStack.SetTop(first);
+      interpreter.CodeStack.Top = first;
     }
   }
@@ -270,5 +271,5 @@
 
 
-      interpreter.CodeStack.SetTop(result);
+      interpreter.CodeStack.Top = result;
     }
   }
@@ -304,5 +305,5 @@
       expressions.Add(interpreter.CodeStack.Top);
       var result = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, expressions);
-      interpreter.CodeStack.SetTop(result);
+      interpreter.CodeStack.Top = result;
     }
   }
@@ -335,5 +336,5 @@
       var result = container ?? PushProgram.Empty;
 
-      interpreter.CodeStack.SetTop(result);
+      interpreter.CodeStack.Top = result;
     }
 
@@ -511,8 +512,8 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var expression = (PushProgram)interpreter.CodeStack.Top;
-      var index = (int)Math.Abs(interpreter.IntegerStack.Pop() % expression.TotalCount);
+      var index = interpreter.IntegerStack.Pop().AsInt(expression.TotalCount);
       var result = expression.GetFromTree(index);
 
-      interpreter.CodeStack.SetTop(result);
+      interpreter.CodeStack.Top = result;
     }
   }
@@ -534,5 +535,6 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var value = interpreter.BooleanStack.Pop();
-      var expression = new BooleanPushExpression(value);
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<BooleanPushExpression>();
+      var expression = BooleanPushExpression.Create(pool, value);
 
       interpreter.CodeStack.Push(expression);
@@ -556,5 +558,6 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var value = interpreter.FloatStack.Pop();
-      var expression = new FloatPushExpression(value);
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<FloatPushExpression>();
+      var expression = FloatPushExpression.Create(pool, value);
 
       interpreter.CodeStack.Push(expression);
@@ -578,5 +581,6 @@
     public override void Eval(IInternalPushInterpreter interpreter) {
       var value = interpreter.IntegerStack.Pop();
-      var expression = new IntegerPushExpression(value);
+      var pool = interpreter.PoolContainer.GetStatefulExpressionPool<IntegerPushExpression>();
+      var expression = IntegerPushExpression.Create(pool, value);
 
       interpreter.CodeStack.Push(expression);
@@ -626,9 +630,9 @@
       var source = interpreter.CodeStack[1];
       var target = (PushProgram)interpreter.CodeStack.Pop();
-      var index = (int)interpreter.IntegerStack.Pop();
 
       IList<Expression> newExpressions;
       if (!target.IsEmpty) {
-        index = target.Expressions.Count - 1 - Math.Abs(index % target.Expressions.Count);
+        var index = interpreter.IntegerStack.Pop().AsInt(target.Expressions.Count);
+        index = target.Expressions.Count - 1 - index;
         newExpressions = target.CopyExpressions(interpreter.PoolContainer.ExpressionListPool);
 
@@ -642,5 +646,5 @@
 
       var result = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, newExpressions as IReadOnlyList<Expression>);
-      interpreter.CodeStack.SetTop(result);
+      interpreter.CodeStack.Top = result;
     }
   }
@@ -699,5 +703,5 @@
 
       var expandExpression = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, expressions);
-      interpreter.CodeStack.SetTop(expandExpression);
+      interpreter.CodeStack.Top = expandExpression;
     }
   }
@@ -759,5 +763,5 @@
           nthExpression = PushProgram.Empty;
         } else {
-          var index = (int)(subExpression.Expressions.Count - 1 - Math.Abs(n % subExpression.Expressions.Count));
+          var index = (subExpression.Expressions.Count - 1 - n.AsInt(subExpression.Expressions.Count));
 
           nthExpression = subExpression.Expressions[index];
@@ -767,5 +771,5 @@
       }
 
-      interpreter.CodeStack.SetTop(nthExpression);
+      interpreter.CodeStack.Top = nthExpression;
     }
   }
@@ -802,5 +806,5 @@
           nthExpression = PushProgram.Empty;
         } else {
-          var index = (int)(subExpressions.Count - 2 - Math.Abs(n % (subExpressions.Count - 1)));
+          var index = subExpressions.Count - 2 - n.AsInt(subExpressions.Count - 1);
 
           nthExpression = subExpressions[index];
@@ -810,5 +814,5 @@
       }
 
-      interpreter.CodeStack.SetTop(nthExpression);
+      interpreter.CodeStack.Top = nthExpression;
     }
   }
@@ -929,5 +933,5 @@
 
       var result = PushProgram.Create(interpreter.PoolContainer.PushProgramPool, newExpressions);
-      interpreter.CodeStack.SetTop(result);
+      interpreter.CodeStack.Top = result;
     }
   }
